<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.util.genarr;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.util.List;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.util.ListIterator;<a name="line.37"></a>
<FONT color="green">038</FONT>    <a name="line.38"></a>
<FONT color="green">039</FONT>    public interface GenericArray&lt;T&gt; extends ArrayIterable&lt;T&gt;, List&lt;T&gt; {<a name="line.39"></a>
<FONT color="green">040</FONT>            int length();<a name="line.40"></a>
<FONT color="green">041</FONT>            boolean isEmpty();<a name="line.41"></a>
<FONT color="green">042</FONT>            <a name="line.42"></a>
<FONT color="green">043</FONT>            T get(int index) throws IndexOutOfBoundsException;<a name="line.43"></a>
<FONT color="green">044</FONT>            T first() throws IndexOutOfBoundsException;<a name="line.44"></a>
<FONT color="green">045</FONT>            T last() throws IndexOutOfBoundsException;<a name="line.45"></a>
<FONT color="green">046</FONT>    <a name="line.46"></a>
<FONT color="green">047</FONT>            T set(int index, T obj) throws IndexOutOfBoundsException;<a name="line.47"></a>
<FONT color="green">048</FONT>            void set(int offset, T[] arr) throws IndexOutOfBoundsException;<a name="line.48"></a>
<FONT color="green">049</FONT>            void set(int offset, T[] arr, int srcOffset, int length) throws IndexOutOfBoundsException;<a name="line.49"></a>
<FONT color="green">050</FONT>            void set(int offset, Iterable&lt;? extends T&gt; it) throws IndexOutOfBoundsException;<a name="line.50"></a>
<FONT color="green">051</FONT>            <a name="line.51"></a>
<FONT color="green">052</FONT>            void swap(int indexA, int indexB);<a name="line.52"></a>
<FONT color="green">053</FONT>    <a name="line.53"></a>
<FONT color="green">054</FONT>            ListIterator&lt;T&gt; iterator();//from iterable<a name="line.54"></a>
<FONT color="green">055</FONT>            ListIterator&lt;T&gt; iterator(final int start, final int end);<a name="line.55"></a>
<FONT color="green">056</FONT>            Iterable&lt;T&gt; iterable(final int start, final int end);<a name="line.56"></a>
<FONT color="green">057</FONT>            <a name="line.57"></a>
<FONT color="green">058</FONT>            void copyTo(GenericArray&lt;? super T&gt; dst, int srcPos, int dstPos, int length);<a name="line.58"></a>
<FONT color="green">059</FONT>            void copyFrom(GenericArray&lt;? extends T&gt;  src, int srcPos, int dstPos, int length);<a name="line.59"></a>
<FONT color="green">060</FONT>    <a name="line.60"></a>
<FONT color="green">061</FONT>            Object[] toArray();<a name="line.61"></a>
<FONT color="green">062</FONT>            &lt;TT&gt; TT[] toArray(TT[] arr);<a name="line.62"></a>
<FONT color="green">063</FONT>    }<a name="line.63"></a>




























































</PRE>
</BODY>
</HTML>
